<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 foldmethod=marker: */
// $HeadURL: https://svn.osuosl.org/public/maintain-project/tags/release-3.0.0-RC1/class/update.php $
// +------------------------------------------------------------------------+
// | Maintain - DNS/DHCP Managment Tool                                     |       
// +------------------------------------------------------------------------+
// | Copyright (c) 2004 Open Source University                              |
// +------------------------------------------------------------------------+
// | This program is free software; you can redistribute it and/or          |
// | modify it under the terms of the GNU General Public License            |
// | as published by the Free Software Foundation; either version 2         |
// | of the License, or (at your option) any later version.                 |
// |                                                                        |
// | This program is distributed in the hope that it will be useful,        |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of         |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
// | GNU General Public License for more details.                           |
// |                                                                        |
// | You should have received a copy of the GNU General Public License      |
// | along with this program; if not, write to the Free Software            |
// | Foundation, Inc., 59 Temple Place - Suite 330,                         |
// | Boston, MA  02111-1307, USA.                                           |
// +------------------------------------------------------------------------+
// | Author(s): Zack Bartel <bartel@osuosl.org>                             |
// +------------------------------------------------------------------------+
// $Id: update.php 4450 2006-06-02 23:17:33Z bartel $


/**
  * update.php - Contains the {@link Update} class
  *
  * @author $Author: bartel $
  * @filesource
  *
  * @package    classes
  */

/**
  * This class handles upgrading Maintain from one version to the next.
  *
  * Versions are a 6-digit number:
  * 
  *     220000
  *     ^       Major Revision
  *
  *     220000
  *      ^      Minor Revision
  *
  * The last four digits are the build number
  *
  * @package    classes
  */
class Update {

    var $version;

//{{{ constructor
    function Update()
    {
        $this->version = $this->get_version();
    }
//}}}
//{{{ get_version()
    function get_version() {


		/* Make sure that update_info exits */
        $sql = "SHOW TABLES LIKE 'update_info'";
        $db_results = mysql_query($sql, dbh());

		// If no table
		if (!mysql_num_rows($db_results)) {
			
			$version = '220000';		
			
		} // if table isn't found

		else {
			// If we've found the update_info table, let's get the version from it

			$sql = "SELECT * FROM update_info WHERE `key`='db_version'";
            $db_results = mysql_query($sql, dbh());
            $results = mysql_fetch_object($db_results);
			$version = $results->value;
		} 
		return $version;
	}
///}}}
//{{{ run_update()
    function run_update()
    {
        global $conf;
        $result = true;
        switch ($this->version)
        {
        case "220000":
        case "240001":
            $script = $conf['paths']['prefix']."/install/sql/migrate2_4-3.sql";
            $query = fread(fopen($script, "r"), filesize($script));  

            $dbh = dbh();
            $stmts = explode(";", $query);
            foreach ($stmts as $sql)
                if ($sql[0] != '-' && $sql[0] != '#')
                    mysql_query($sql, $dbh);
             return true;
        }
    }
//}}}
} // end update class

?>
